extern "C"
{
#include <misc_tools.h>
#include <fxlib.h>
#include "Sonic.h"
#include "sonic_tileset.h"
#include "rand.h"
#include "text_ascii.h"
#include "sprites.h"
#include "fct.c"




void G3A_main()
{
    int freq;
	freq = (*((volatile unsigned int*)0xA4150000) & 0x3F000000) >> 24;
	if (freq < 0x0b010111)
	{
	    overclock(0x0b010111);
	}
	random(RTC_GetTicks());
	int scrolling_arriereplan = 0;
    int scrolling_premierplan = 0;
    do
    {
        do
        {
            for(int i=0;i<=512;i+=256)
                alphaSprite(i-scrolling_arriereplan,0,256,216,(short*)bg1_1,0x0000);
            for(int i=0;i<=186*3;i+=186)
                alphaSprite(i-scrolling_premierplan,0,186,216,(short*)bg2_1,0x0000);
            alphaSprite(46,29,291,100,(short*)logo,0x0000);
            print_text_cg( 1,200,"Copyright Smashmaster 2012",0x0000);
            Rectangle((LCD_WIDTH_PX/2)-58,152,(LCD_WIDTH_PX/2)+58,172,0xffff);
            Rectangle((LCD_WIDTH_PX/2)-56,154,(LCD_WIDTH_PX/2)+56,170,0x0000);
            print_text_cg( text_center_coord_x("PRESS ALPHA"),158,"PRESS ALPHA",0xffff);
            Flip();
            scrolling_arriereplan++;
            scrolling_premierplan+=2;
            if (scrolling_arriereplan == 257)
                scrolling_arriereplan = 0;
            if (scrolling_premierplan == 188)
                scrolling_premierplan = 0;
        }while(!keydown(77) && !keydown(47)&& !keydown(48));
        if (!keydown(47)&& !keydown(48))
            game();
    }while (!keydown(47)&& !keydown(48));
	overclock(freq);
}

void game()
{
    int i,j,ennemieTue = 0;
    struct _SONIC sonics;
    int jump_counter;
    int scrolling_arriereplan = 0;
    int scrolling_deuxiemplan = 0;
    struct _SCROL scrolling;
    int position;
    int score = 0;
    int time = 0;
    bool gameOver;
    bool peutAttaquer ;
    int lev = 1;
    do
    {
        do{}while(keydown(77));
        createLvl(lev);
        peutAttaquer = true;
        gameOver = false;
        position = 2;
        jump_counter = 0;
        sonics.attack = false;
        sonics.fall = false;
        sonics.jump = false;
        sonics.y = 152;
        sonics.etat_animation = 0;
        scrolling.x = 0;
        scrolling.y = 0;
        AfficheBackground(scrolling_arriereplan,scrolling_deuxiemplan,scrolling.y);
        Rectangle((LCD_WIDTH_PX/2)-80,94,(LCD_WIDTH_PX/2)+80,128,0xffff);
        Rectangle((LCD_WIDTH_PX/2)-80,96,(LCD_WIDTH_PX/2)+80,126,0x0000);
        print_number_cg(print_text_cg(text_center_coord_x("Get ready for level "),100,"Get ready for level ",0xffff),100,lev,0xffff);
        print_text_cg( text_center_coord_x("Press ALPHA to continue"),114,"Press ALPHA to continue",0xffff);
        Flip();
        Keydown_onePress(77);
        do
        {
            AfficheBackground(scrolling_arriereplan,scrolling_deuxiemplan,scrolling.y);
            AnnimeMap(position);
            afficheMap(position,scrolling);
            if (!sonics.fall && !sonics.jump && !sonics.attack) alphaSprite(96-6,sonics.y-6+scrolling.y,38,38,(short*)sonic[sonics.etat_animation],0x051d);
            if (sonics.fall && !sonics.jump && !sonics.attack) alphaSprite(96-6,sonics.y-6+scrolling.y,38,38,(short*)sonic_fall,0x051d);
            if (!sonics.fall && sonics.jump && !sonics.attack) alphaSprite(96-6,sonics.y-6+scrolling.y,38,38,(short*)sonic_jump,0x051d);
            if (sonics.attack) alphaSprite(96-6-8,sonics.y-6+scrolling.y,55,38,(short*)sonic_attack[sonics.etat_animation],0x051d);
            Rectangle(0,0,90,15,0x0000);
            print_number_cg(print_text_cg(2,2,"Score : ",0xffff),2,time-2*(time-score)+50*ennemieTue,0x051d);
            Flip();
            /*scrolling vertical*/
            if(sonics.y<89)
            {
                scrolling.y = 89-sonics.y;
            }
            else
            {
                scrolling.y = 0;
            }
            /*sonic qui attaque*/
           if(!keydown(77) && !peutAttaquer)
                peutAttaquer = true;

            if (keydown(77) && (sonics.fall || sonics.jump) && !sonics.attack && peutAttaquer)
            {
                sonics.attack = true;
                sonics.etat_animation = 0;
            }
            if (sonics.attack && level[(sonics.y-8)/32][position]>=MORTEL+2)
            {
                if (level[(sonics.y-8)/32][position] %2 == 1)     {level[(sonics.y-8)/32][position+1] = 0;}
                else {level[(sonics.y-8)/32][position-1]=0;}
                level[(sonics.y-8)/32][position]=0;
                ennemieTue ++;
            }
            /*fin sonic qui attaque*/
            /*sonic qui meurt*/
            j = (sonics.y-8)/32;
            if (level[j][position]>=MORTEL)
            {
                gameOver = true;
                for (i = 0;i<4;i++) //annimation de sonic qui meurt
                {
                    AfficheBackground(scrolling_arriereplan,scrolling_deuxiemplan,scrolling.y);
                    AnnimeMap(position);
                    afficheMap(position,scrolling);
                    alphaSprite(96,sonics.y-6+scrolling.y,33,39,(short*)sonic_dead[i],0x051d);
                    Flip();
                }
                for (i = sonics.y-6+scrolling.y;i<=216;i+=8)
                {
                    AfficheBackground(scrolling_arriereplan,scrolling_deuxiemplan,scrolling.y);
                    AnnimeMap(position);
                    afficheMap(position,scrolling);
                    alphaSprite(96,i,33,39,(short*)sonic_dead[3],0x051d);
                    Flip();
                }
                    Rectangle(48,48,LCD_WIDTH_PX-48,LCD_HEIGHT_PX-48,0x051d);
                    Rectangle(50,50,LCD_WIDTH_PX-50,LCD_HEIGHT_PX-50,0x0000);
                    print_text_cg(text_center_coord_x("G A M E    O V E R"),52,"G A M E    O V E R",0xffff);

                    print_number_cg(print_text_cg(57,74,"Distance               : ",0xffff),74,time,0xffff);
                    print_number_cg(print_text_cg(57,88,"Stop                   : ",0xffff),88,-2*(time-score),0xffff);
                    print_number_cg(print_text_cg(57,102,"Number of enemy killed : ",0xffff),102,ennemieTue,0xffff);
                    print_number_cg(print_text_cg(57,120,"Total score            : ",0x051d),120,time-2*(time-score)+50*ennemieTue,0x051d);
                    print_text_cg(text_center_coord_x("Press ALPHA"),LCD_HEIGHT_PX-10-2-11-40,"Press ALPHA",0xffff);
                    Flip();
                    Keydown_onePress(77);
            }
            /*fin sonic qui meurt*/


            /*sonic qui tombe*/

            if (level[(sonics.y+7+1)/32][position] <MORTEL && level[(sonics.y+7+1)/32][position] != 0)
                sonics.fall = false;
            if ((level[(sonics.y+7+1)/32][position] >=MORTEL || level[(sonics.y+7+1)/32][position] ==0) && sonics.jump == false)
            {
                sonics.fall = true;
                sonics.y+=8;
            }
            /*fin sonic qui tombe*/
            /*sonic qui saute*/
            if ((keydown(28) || keydown(78))&&(!sonics.jump && !sonics.fall))
            {
                sonics.jump = true;
                jump_counter = 13;
            }
            if (jump_counter &&(keydown(28) || keydown(78))&& !sonics.fall)
            {
                jump_counter--;
                sonics.y-=8;
            }
            else
            {
                sonics.jump = false;
            }
            if(sonics.y<=24)
            {
                sonics.jump = false;
                sonics.fall = true;
                jump_counter = 0;
            }
            /*fin sonic qui saute*/

            time++;
            if ((level[(sonics.y+7)/32][position+1]>=MORTEL  && level[(sonics.y-24)/32][position+1]>=MORTEL)||(level[(sonics.y+7)/32][position+1]==0 && level[(sonics.y-24)/32][position+1]==0)||(level[(sonics.y+7)/32][position+1]==0  && level[(sonics.y-24)/32][position+1]>=MORTEL)||(level[(sonics.y+7)/32][position+1]>=MORTEL  && level[(sonics.y-24)/32][position+1]==0))
            {
                score++;
                (scrolling.x)+=8;
                scrolling_arriereplan++;
                scrolling_deuxiemplan+=2;
                if (scrolling_arriereplan == 256)
                    scrolling_arriereplan = 0;
                if (scrolling_deuxiemplan == 186)
                    scrolling_deuxiemplan = 0;
                if (scrolling.x == 32)
                {
                    scrolling.x = 0;
                    position ++;
                }
            }
            sonics.etat_animation++;
            if (sonics.etat_animation == 7)
            {
                sonics.etat_animation = 0;
                if (sonics.attack)
                {
                    sonics.attack = false;
                    peutAttaquer = false; // pour eviter que le joueur laisse le bouton "alpha" appuyer dessus
                }
            }
        }while(!keydown(47) && position != 91 && !gameOver);
        if (!gameOver && !keydown(47))
        {
            lev++;
            Rectangle((LCD_WIDTH_PX/2)-62,96,(LCD_WIDTH_PX/2)+62,113,0xffff);
            Rectangle((LCD_WIDTH_PX/2)-62,98,(LCD_WIDTH_PX/2)+62,111,0x0000);
            print_text_cg(text_center_coord_x("Level completed"),100,"Level completed",0xffff);
            Flip();
            Keydown_onePress(77);
        }
    }while (!gameOver && !keydown(47));
    if (keydown(77))
    {
        Keydown_onePress(77);
    }
}

void createLvl(int lev)
{
    int i,j;
    int alea;
    for (i = 0 ; i<100;i++)
    {
        level[5][i] = i%2 + 1;
        for (j = 0;j<5;j++)
            level[j][i]= 0;
    }
    for (i=10;i<100;i++)
    {
        alea = random() % 100;
        if (alea >90-2*(lev-1))
        {
            if (level[3][i] == 0)
            {
                if(alea == 95-3*(lev-1)) level [2][i+2]= MORTEL;
                if(alea >= 94-3*(lev-1) && alea <= 95 && level [4][i-1]== 0)level [4][i-1]= MORTEL+1;
                level[3][i+1] = 4;
                level[3][i] = 3;
                level[4][i+1] = 6;
                level[4][i] = 5;
            }
        }
        if (alea<=90-2*(lev-1) && alea>80-4*(lev-1))
        {
            level[5][i] = MORTEL;
        }
        if (alea>=75-4*(lev-1) && alea<80-4*(lev-1) && level[2][i] == 0 && level[2][i+1] == 0)
        {
            level[2][i] = MORTEL+2;
            level[2][i+1] = MORTEL+3;
        }
        if (alea>=70-6*(lev-1) && alea<77-3*(lev-1) && level[1][i] == 0 && level[1][i+1] == 0)
        {
            level[1][i] = MORTEL+2;
            level[1][i+1] = MORTEL+3;
        }
    }
}

void afficheMap(int pos, struct _SCROL scroll)
{
    int i,j;
    for (i=0;i<13;i++)
    {
        for(j=0;j<6;j++)
        {
            if(i+pos-4>=0) alphaSprite(i*32-scroll.x,j*32+24+scroll.y,32,32,(short*)sprites[level[j][i+pos-3]],0x8408);
        }
    }
}

void AfficheBackground(int scrol1,int scrol2,int scrolVert)
{
    for(int i=0;i<=512;i+=256)
    {
        alphaSprite(i-scrol1,-16+scrolVert/4,256,216,(short*)bg1_1,0x0000); //affiche l'arriere plan
        alphaSprite(i-scrol1,200+scrolVert/4,256,16,(short*)bg1_2,0x0000);
    }
    for(int i=0;i<=186*3;i+=186)
        alphaSprite(i-scrol2,scrolVert/2,186,216,(short*)bg2_1,0x0000); //affiche les tours
}

void AnnimeMap(int pos)
{
    int i,j;
    for (i=0;i<13;i++)
    {
        for(j=0;j<6;j++)
        {
            if (level[j][i+pos-3]>=MORTEL+2 && level[j][i+pos-3]%2!=0)
            {
                level[j][i+pos-3]+=2;
                level[j][i+pos-2]=level[j][i+pos-3]+1;
                if (level[j][i+pos-3]>=MORTEL+14)
                {
                    level[j][i+pos-3] = MORTEL + 2;
                    level[j][i+pos-2] = MORTEL + 3;
                }

            }
        }
    }
}

void Keydown_onePress (int a)
{
    do{}while(!keydown(a));
    do{}while(keydown(a));
}


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section

}

